//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_color6  Gold
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern double Period1             = 32;
extern double Period2             =  5;
extern double Period3             =  5;
extern bool   alertsOn            = false;
extern bool   alertsOnZeroCross   = true;
extern bool   alertsOnSignalCross = true;
extern bool   alertsOnCurrent     = true;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = false;
extern bool   alertsEmail         = false;

double eco[];
double ecohuu[];
double ecohud[];
double ecohdd[];
double ecohdu[];
double signal[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,ecohuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,ecohud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,ecohdd); SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,ecohdu); SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,eco);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,slope);
      IndicatorShortName("Blau ergodic candlestick oscillator ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double trend[][2];
#define _signal 0
#define _zeroli 1
 
int start()
{
   int i,r,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);

   //
   //
   //
   //
   //

      for(i=limit, r=Bars-i-1; i >= 0; i--,r++)
      {
         double co = iEma(iEma(Close[i]-Open[i],Period1,i,0),Period2,i,1);
         double hl = iEma(iEma(High[i]-Low[i],Period1,i,2),Period2,i,3);
            if (hl!=0)
                  eco[i] = 100.0*co/hl;
            else  eco[i] = 0;                  
            ecohuu[i] = EMPTY_VALUE;
            ecohud[i] = EMPTY_VALUE;
            ecohdd[i] = EMPTY_VALUE;
            ecohdu[i] = EMPTY_VALUE;
            signal[i] = iEma(eco[i],Period3,i,4);

            //
            //
            //
            //
            //
                           
            trend[r][_zeroli] = trend[r-1][_zeroli];
            trend[r][_signal] = trend[r-1][_signal];
            slope[i] = slope[i+1];
               if (eco[i] > signal[i]) trend[r][_signal] =  1;
               if (eco[i] < signal[i]) trend[r][_signal] = -1;
               if (eco[i] > 0)         trend[r][_zeroli] =  1;
               if (eco[i] < 0)         trend[r][_zeroli] = -1;
               if (eco[i] > eco[i+1])  slope[i] =  1;
               if (eco[i] < eco[i+1])  slope[i] = -1;
               if (eco[i]>0)
               if (slope[i]==1)
                     ecohuu[i] = eco[i];
               else  ecohud[i] = eco[i];
               if (eco[i]<0)
               if (slope[i]==1)
                     ecohdu[i] = eco[i];
               else  ecohdd[i] = eco[i];
      }
   manageAlerts();
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][5];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
} 


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-whichBar-1;
      
      //
      //
      //
      //
      //
            
      if (alertsOnZeroCross && trend[whichBar][_zeroli] != trend[whichBar-1][_zeroli])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (trend[whichBar][_zeroli] ==  1) doAlert(time1,mess1," Blau ECO crossed zero line up");
            if (trend[whichBar][_zeroli] == -1) doAlert(time1,mess1," Blau ECO crossed zero line down");
      }
      if (alertsOnSignalCross && trend[whichBar][_signal] != trend[whichBar-1][_signal])
      {
         static datetime time2 = 0;
         static string   mess2 = "";
            if (trend[whichBar][_signal] ==  1) doAlert(time2,mess2," Blau ECO crossed signal line up");
            if (trend[whichBar][_signal] == -1) doAlert(time2,mess2," Blau ECO crossed signal line down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" Blau ECO",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

